commit f3ac1c962f9e3d7ff7d55141220df97c2b343ada
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 18:08:00 2019 +0100

    Applied a file structure template to all source files.

diff --git a/core/inc/aos_system.h b/core/inc/aos_system.h
index c571c03..b958c2a 100644
--- a/core/inc/aos_system.h
+++ b/core/inc/aos_system.h
@@ -34,6 +34,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #include <aos_time.h>
 #include <chprintf.h>
 
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
 /**
  * @brief   Resolution of the system time measurement.
  */
@@ -64,18 +68,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define AOS_SYSTEM_EVENTFLAGS_RESTART           (AOS_SYSTEM_EVENTFLAGS_SHUTDOWN | (eventflags_t)(1 << 4))
 
-/**
- * @brief   Enumerator to identify shutdown types.
- */
-typedef enum aos_shutdown {
-  AOS_SHUTDOWN_NONE,            /**< Default value if no shutdown action was initiated */
-  AOS_SHUTDOWN_PASSIVE,         /**< Passive shutdown (initiated by another module). */
-  AOS_SHUTDOWN_HIBERNATE,       /**< Active shutdown to hibernate mode. */
-  AOS_SHUTDOWN_DEEPSLEEP,       /**< Active shutdown to deepsleep mode. */
-  AOS_SHUTDOWN_TRANSPORTATION,  /**< Active shutdown to transportation mode. */
-  AOS_SHUTDOWN_RESTART,         /**< Active saystem restart request. */
-} aos_shutdown_t;
-
 #if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
 
 /**
@@ -94,6 +86,34 @@ typedef enum aos_shutdown {
  */
 #define AOS_SYSTEM_SSSP_TIMEOUT                 (10 * AMIROOS_CFG_SSSP_SIGNALDELAY)
 
+#endif /* AMIROOS_CFG_SSSP_ENABLE == true */
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Enumerator to identify shutdown types.
+ */
+typedef enum aos_shutdown {
+  AOS_SHUTDOWN_NONE,            /**< Default value if no shutdown action was initiated */
+  AOS_SHUTDOWN_PASSIVE,         /**< Passive shutdown (initiated by another module). */
+  AOS_SHUTDOWN_HIBERNATE,       /**< Active shutdown to hibernate mode. */
+  AOS_SHUTDOWN_DEEPSLEEP,       /**< Active shutdown to deepsleep mode. */
+  AOS_SHUTDOWN_TRANSPORTATION,  /**< Active shutdown to transportation mode. */
+  AOS_SHUTDOWN_RESTART,         /**< Active saystem restart request. */
+} aos_shutdown_t;
+
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
 /**
  * @brief   Enumerator of the several stages of SSSP.
  */
@@ -176,10 +196,9 @@ typedef struct aos_system {
 
 } aos_system_t;
 
-/**
- * @brief   Global system object.
- */
-extern aos_system_t aos;
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
 
 /**
  * @brief   Printf function that uses the default system I/O stream.
@@ -188,6 +207,15 @@ extern aos_system_t aos;
  */
 #define aosprintf(fmt, ...)                     chprintf((BaseSequentialStream*)&aos.iostream, fmt, ##__VA_ARGS__)
 
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+/**
+ * @brief   Global system object.
+ */
+extern aos_system_t aos;
+
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -211,6 +239,10 @@ extern "C" {
 }
 #endif
 
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
 /**
  * @brief   Retrieves the system uptime.
  *