commit 1d4fc1800fbb28e3dab9507b88c5b21492ba7f20
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Tue Nov 6 14:46:19 2018 +0100

    enhanced UML component diagram

diff --git a/docs/AMiRo-LLD.svg b/docs/AMiRo-LLD.svg
index b402198..4038f8e 100644
--- a/docs/AMiRo-LLD.svg
+++ b/docs/AMiRo-LLD.svg
@@ -1,11 +1,17 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="183px" preserveAspectRatio="none" style="width:130px;height:183px;" version="1.1" viewBox="0 0 130 183" width="130px" zoomAndPan="magnify"><defs><filter height="300%" id="f12h6c2g39dm6b" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--entity periphAL.h--><ellipse cx="62.5" cy="37" fill="#FEFECE" filter="url(#f12h6c2g39dm6b)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="26" y="66.9951">periphAL.h</text><!--entity AMiRoLLD--><rect fill="#FEFECE" filter="url(#f12h6c2g39dm6b)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="113" x="6" y="126"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="99" y="131"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="97" y="133"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="97" y="137"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="21" y="158.9951">AMiRo-LLD</text><!--link periphAL.h to AMiRoLLD--><path d="M62.5,46.268 C62.5,62.956 62.5,101.1637 62.5,125.7129 " fill="none" id="periphAL.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--
+<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="256px" preserveAspectRatio="none" style="width:285px;height:256px;" version="1.1" viewBox="0 0 285 256" width="285px" zoomAndPan="magnify"><defs><filter height="300%" id="f1i4ndtq797wdb" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--cluster AMiRoLLD_node--><polygon fill="#FFFFFF" filter="url(#f1i4ndtq797wdb)" points="104,34,114,24,263,24,263,234,253,244,104,244,104,34" style="stroke: #000000; stroke-width: 1.5;"/><line style="stroke: #000000; stroke-width: 1.5;" x1="253" x2="262" y1="34" y2="25"/><line style="stroke: #000000; stroke-width: 1.5;" x1="104" x2="253" y1="34" y2="34"/><line style="stroke: #000000; stroke-width: 1.5;" x1="253" x2="253" y1="34" y2="244"/><text fill="#000000" font-family="sans-serif" font-size="14" font-weight="bold" lengthAdjust="spacingAndGlyphs" textLength="83" x="138" y="49.9951">AMiRo-LLD</text><!--entity periphAL.h--><ellipse cx="177" cy="93" fill="#FEFECE" filter="url(#f1i4ndtq797wdb)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="140.5" y="122.9951">periphAL.h</text><!--entity AMiRoLLD--><rect fill="#FEFECE" filter="url(#f1i4ndtq797wdb)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="113" x="120.5" y="182"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="213.5" y="187"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="211.5" y="189"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="211.5" y="193"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="135.5" y="214.9951">AMiRo-LLD</text><!--entity alldconf.h--><ellipse cx="47" cy="93" fill="#FEFECE" filter="url(#f1i4ndtq797wdb)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="66" x="14" y="122.9951">alldconf.h</text><!--link alldconf.h to AMiRoLLD--><path d="M64.2402,108.588 C86.4276,127.362 125.181,160.1527 150.966,181.9712 " fill="none" id="alldconf.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M53.2357,110.3553 A9,9 0 0 0 64.1623 97.4437" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link periphAL.h to AMiRoLLD--><path d="M177,102.268 C177,118.956 177,157.164 177,181.7129 " fill="none" id="periphAL.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--
 @startuml
 skinparam componentStyle uml2
 
-interface periphAL.h
 
-component "AMiRo-LLD" as AMiRoLLD
-AMiRoLLD -up- periphAL.h
+interface alldconf.h
+
+node "AMiRo-LLD" as AMiRoLLD_node {
+	interface periphAL.h
+
+	component "AMiRo-LLD" as AMiRoLLD
+	AMiRoLLD -up-( alldconf.h
+	AMiRoLLD -up- periphAL.h
+}
 
 @enduml
 
diff --git a/docs/AMiRo-LLD.uml b/docs/AMiRo-LLD.uml
index 1c7336d..c9cdfec 100644
--- a/docs/AMiRo-LLD.uml
+++ b/docs/AMiRo-LLD.uml
@@ -19,10 +19,19 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 @startuml
 skinparam componentStyle uml2
 
-interface periphAL.h
+'-------------------------------------------------------------------------------
+' AMiRo-LLD
+'-------------------------------------------------------------------------------
 
-component "AMiRo-LLD" as AMiRoLLD
-AMiRoLLD -up- periphAL.h
+interface alldconf.h
+
+node "AMiRo-LLD" as AMiRoLLD_node {
+	interface periphAL.h
+
+	component "AMiRo-LLD" as AMiRoLLD
+	AMiRoLLD -up-( alldconf.h
+	AMiRoLLD -up- periphAL.h
+}
 
 @enduml
 