commit 4a0e2139b54bbe317e7d1a35ac1048798c47253f
Author: Julian L <diki1aap@gmail.com>
Date:   Mon Jan 28 11:19:11 2019 +0100

    Powermanagment unittest data send/receive

diff --git a/bootloader/AMiRo-BLT b/bootloader/AMiRo-BLT
index 2880bac..03906dc 160000
--- a/bootloader/AMiRo-BLT
+++ b/bootloader/AMiRo-BLT
@@ -1 +1 @@
-Subproject commit 2880bac8f7c2bc4873cfdd9e88a914fb10659f59
+Subproject commit 03906dc3eea1bcc0aa880aeadd1bc1ba1d26d472
diff --git a/core/core.mk b/core/core.mk
index c647a16..9ed1b38 100644
--- a/core/core.mk
+++ b/core/core.mk
@@ -30,7 +30,19 @@ AMIROOS_CORE_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
 AMIROOSCOREINC = $(AMIROOS_CORE_DIR)inc
 
 # C source files
+<<<<<<< Updated upstream
 AMIROOSCORECSRC = $(wildcard $(AMIROOS_CORE_DIR)src/*.c)
+=======
+AMIROOSCORECSRC = $(AMIROOS_CORE_DIR)src/aos_debug.c \
+                  $(AMIROOS_CORE_DIR)src/aos_iostream.c \
+                  $(AMIROOS_CORE_DIR)src/aos_rtcan.c \
+                  $(AMIROOS_CORE_DIR)src/aos_shell.c \
+                  $(AMIROOS_CORE_DIR)src/aos_system.c \
+                  $(AMIROOS_CORE_DIR)src/aos_thread.c \
+                  $(AMIROOS_CORE_DIR)src/aos_time.c \
+                  $(AMIROOS_CORE_DIR)src/aos_timer.c \
+                  $(AMIROOS_CORE_DIR)src/aos_unittest.c
+>>>>>>> Stashed changes
 
 # C++ source files
 AMIROOSCORECPPSRC = $(wildcard $(AMIROOS_CORE_DIR)src/*.c?*)
diff --git a/modules/PowerManagement_1-1/module.c b/modules/PowerManagement_1-1/module.c
index 99214e3..9881c6f 100644
--- a/modules/PowerManagement_1-1/module.c
+++ b/modules/PowerManagement_1-1/module.c
@@ -90,7 +90,7 @@ PWMConfig moduleHalPwmBuzzerConfig = {
       /* mode                   */ PWM_OUTPUT_ACTIVE_HIGH,
       /* callback               */ NULL
     },
-    /* channel 2              */ {
+    /* channel 2  f            */ {
       /* mode                   */ PWM_OUTPUT_DISABLED,
       /* callback               */ NULL
     },
@@ -1473,6 +1473,37 @@ aos_unittest_t moduleUtAlldAt42qt1050 = {
 
 #endif /* BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X */
 
+static ut_rtcandata_t _utLldRtCanData = {
+    /*operation */ NULL
+};
+
+static int _utShellCmdCb_LldRtCan(BaseSequentialStream* stream, int argc, char* argv[])
+{
+    if(argc == 2 ){
+        if (strcmp(argv[1], "send") == 0) {
+            ((ut_rtcandata_t*)moduleUtLldRtCan.data)->operation = "send";
+            aosUtRun(stream, &moduleUtLldRtCan,NULL);
+            return AOS_OK;
+        }else if(strcmp(argv[1], "receive") == 0){
+            ((ut_rtcandata_t*)moduleUtLldRtCan.data)->operation = "receive";
+            aosUtRun(stream, &moduleUtLldRtCan,NULL);
+            return AOS_OK;
+        }
+    }
+    return AOS_INVALID_ARGUMENTS;
+}
+aos_unittest_t moduleUtLldRtCan = {
+  /* name           */ "RTCAN",
+  /* info           */ NULL,
+  /* test function  */ utLldRtCanFunc,
+  /* shell command  */ {
+    /* name     */ "unittest:rtcan",
+    /* callback */ _utShellCmdCb_LldRtCan,
+    /* next     */ NULL,
+  },
+  /* data           */ &_utLldRtCanData,
+};
+
 #endif /* AMIROOS_CFG_TESTS_ENABLE == true */
 
 /** @} */
diff --git a/modules/PowerManagement_1-1/module.h b/modules/PowerManagement_1-1/module.h
index 51fabe7..af76738 100644
--- a/modules/PowerManagement_1-1/module.h
+++ b/modules/PowerManagement_1-1/module.h
@@ -444,6 +444,8 @@ extern ROMCONST char* moduleShellPrompt;
   aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113.shellcmd);             \
   aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113Ina219.shellcmd);       \
   MODULE_INIT_TEST_SENSORRING();                                              \
+  aosShellAddCommand(&aos.shell, &moduleUtAlldVcnl4020.shellcmd);             \
+  aosShellAddCommand(&aos.shell, &moduleUtLldRtCan.shellcmd);                 \
 }
 #if (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) || defined(__DOXYGEN__)
   #define MODULE_INIT_TEST_SENSORRING() {                                     \
@@ -732,6 +734,7 @@ extern AT42QT1050Driver moduleLldTouch;
 
 #endif /* BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X */
 
+
 /** @} */
 
 /*===========================================================================*/
@@ -751,6 +754,8 @@ extern AT42QT1050Driver moduleLldTouch;
 #include <ut_alld_pklcs1212e4001.h>
 #include <ut_alld_tps62113.h>
 #include <ut_alld_tps62113_ina219.h>
+#include <ut_alld_vcnl4020.h>
+#include <ut_lld_rtcan.h>
 
 /**
  * @brief   ADC unit test object.
@@ -859,6 +864,11 @@ extern aos_unittest_t moduleUtAlldAt42qt1050;
 
 #endif /* BOARD_SENSORRING == BOARD_DISTANCESENSOR_VL53L1X */
 
+/**
+ * @brief RtCan unit test object.
+*/
+extern aos_unittest_t moduleUtLldRtCan;
+
 #endif /* AMIROOS_CFG_TESTS_ENABLE == true */
 
 /** @} */
diff --git a/periphery-lld/AMiRo-LLD b/periphery-lld/AMiRo-LLD
index bb46c55..11500ad 160000
--- a/periphery-lld/AMiRo-LLD
+++ b/periphery-lld/AMiRo-LLD
@@ -1 +1 @@
-Subproject commit bb46c559fac6ba3c2c9e1516d4a4171213263157
+Subproject commit 11500ad81cfe6291b84e2faaf5731446da4014d4
diff --git a/unittests/unittests.mk b/unittests/unittests.mk
index 10fe749..0ab8842 100644
--- a/unittests/unittests.mk
+++ b/unittests/unittests.mk
@@ -31,6 +31,31 @@ UNITTESTSINC = $(UNITTESTS_DIR)lld/inc \
                $(UNITTESTS_DIR)periphery-lld/inc
 
 # C sources
+<<<<<<< Updated upstream
 UNITTESTSCSRC = $(wildcard $(UNITTESTS_DIR)lld/src/*.c) \
                 $(wildcard $(UNITTESTS_DIR)periphery-lld/src/*.c)
+=======
+UNITTESTSCSRC = $(UNITTESTS_DIR)lld/src/ut_lld_adc.c \
+				$(UNITTESTS_DIR)lld/src/ut_lld_rtcan.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_a3906.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_at24c01bn-sh-b.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_bq24103a.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_bq27500.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_bq27500_bq24103a.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_hmc5883l.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_ina219.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_l3g4200d.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_led.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_lis331dlh.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_ltc4412.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_mpr121.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_pca9544a.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_pklcs1212e4001.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_tlc5947.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_tps2051bdbv.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_tps62113.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_tps62113_ina219.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_vcnl4020.c \
+                $(UNITTESTS_DIR)periphery-lld/src/ut_alld_dw1000.c
+>>>>>>> Stashed changes
 